import { defineComponent as z, useId as I, ref as i, watch as L, createElementBlock as U, openBlock as k, unref as r, createElementVNode as l, createVNode as u, normalizeStyle as A, normalizeClass as M, createBlock as $, createCommentVNode as H, withCtx as N, toDisplayString as b } from "vue";
import { ScalarButton as T, ScalarIcon as D } from "@scalar/components";
import { REQUEST_METHODS as O } from "@scalar/oas-utils/helpers";
import P from "../CodeInput/CodeInput.vue.js";
import K from "../HttpMethod/HttpMethod.vue.js";
import Q from "./AddressBarHistory.vue.js";
import W from "../Server/ServerDropdown.vue.js";
import { useWorkspace as j } from "../../store/store.js";
import { useLayout as F } from "../../hooks/useLayout.js";
const G = ["id"], J = { class: "address-bar-bg-states text-xxs group relative order-last flex w-full max-w-[calc(100dvw-24px)] flex-1 flex-row items-stretch rounded-lg p-0.75 lg:order-none lg:max-w-[580px] lg:min-w-[580px] xl:max-w-[720px] xl:min-w-[720px]" }, X = { class: "pointer-events-none absolute top-0 left-0 block h-full w-full overflow-hidden rounded-lg border" }, Y = { class: "z-context-plus flex gap-1" }, Z = { class: "scroll-timeline-x scroll-timeline-x-hidden z-context-plus relative flex w-full bg-blend-normal" }, _ = {
  "aria-hidden": "true",
  class: "inline-flex items-center gap-1"
}, ee = { class: "sr-only" }, ue = /* @__PURE__ */ z({
  __name: "AddressBar",
  props: {
    collection: {},
    operation: {},
    server: {},
    environment: {},
    envVariables: {},
    workspace: {}
  },
  emits: ["importCurl"],
  setup(n) {
    const p = I(), { requestMutators: m, events: f } = j(), { layout: v } = F(), h = i(null), w = i(null), B = (e) => {
      n.operation.path !== e && m.edit(n.operation.uid, "path", e);
    };
    L(
      () => n.operation.path,
      (e) => {
        e && B(e);
      }
    );
    const t = i(100), x = i(0), a = i(!1), s = i();
    function C() {
      a.value ? t.value -= (t.value - 15) / 60 : t.value -= x.value / 20, t.value <= 0 && (clearInterval(s.value), s.value = void 0, t.value = 100, a.value = !1);
    }
    function y() {
      s.value || (a.value = !0, s.value = setInterval(C, 20));
    }
    function R() {
      x.value = t.value, a.value = !1;
    }
    function q() {
      clearInterval(s.value), s.value = void 0, t.value = 100, a.value = !1;
    }
    f.requestStatus.on((e) => {
      e === "start" && y(), e === "stop" && R(), e === "abort" && q();
    }), f.focusAddressBar.on(() => {
      var e, o, d;
      v === "modal" ? (o = (e = w.value) == null ? void 0 : e.$el) == null || o.focus() : (d = h.value) == null || d.focus();
    });
    function S(e) {
      m.edit(n.operation.uid, "method", e);
    }
    function E() {
      const { method: e } = n.operation;
      return O[e].backgroundColor;
    }
    function g() {
      a.value || (a.value = !0, f.executeRequest.emit({ requestUid: n.operation.uid }));
    }
    f.hotKeys.on((e) => {
      var o;
      e != null && e.focusAddressBar && ((o = h.value) == null || o.focus()), e != null && e.executeRequest && g();
    });
    function V(e) {
      m.edit(n.operation.uid, "path", e);
    }
    return (e, o) => {
      var d;
      return k(), U("div", {
        id: r(p),
        class: "scalar-address-bar order-last flex h-(--scalar-address-bar-height) w-full [--scalar-address-bar-height:32px] lg:order-none lg:w-auto"
      }, [
        l("div", J, [
          l("div", X, [
            l("div", {
              class: M(["absolute top-0 left-0 z-[1002] h-full w-full", E()]),
              style: A({ transform: `translate3d(-${t.value}%,0,0)` })
            }, null, 6)
          ]),
          l("div", Y, [
            u(K, {
              isEditable: r(v) !== "modal",
              isSquare: "",
              method: e.operation.method,
              teleport: "",
              onChange: S
            }, null, 8, ["isEditable", "method"])
          ]),
          l("div", Z, [
            e.collection.servers.length ? (k(), $(r(W), {
              key: 0,
              collection: e.collection,
              layout: "client",
              operation: e.operation,
              server: e.server,
              target: r(p)
            }, null, 8, ["collection", "operation", "server", "target"])) : H("", !0),
            o[1] || (o[1] = l("div", { class: "fade-left" }, null, -1)),
            u(P, {
              ref_key: "addressBarRef",
              ref: h,
              "aria-label": "Path",
              class: "min-w-fit outline-none",
              disableCloseBrackets: "",
              disabled: r(v) === "modal",
              disableEnter: "",
              disableTabIndent: "",
              emitOnBlur: !1,
              envVariables: e.envVariables,
              environment: e.environment,
              importCurl: "",
              modelValue: e.operation.path,
              placeholder: (d = e.server) != null && d.uid && e.collection.servers.includes(e.server.uid) ? "" : "Enter a URL or cURL command",
              server: "",
              workspace: e.workspace,
              onCurl: o[0] || (o[0] = (c) => e.$emit("importCurl", c)),
              onSubmit: g,
              "onUpdate:modelValue": V
            }, null, 8, ["disabled", "envVariables", "environment", "modelValue", "placeholder", "workspace"]),
            o[2] || (o[2] = l("div", { class: "fade-right" }, null, -1))
          ]),
          u(Q, {
            operation: e.operation,
            target: r(p)
          }, null, 8, ["operation", "target"]),
          u(r(T), {
            ref_key: "sendButtonRef",
            ref: w,
            class: "z-context-plus relative h-auto shrink-0 overflow-hidden py-1 pr-2.5 pl-2 font-bold",
            disabled: a.value,
            onClick: g
          }, {
            default: N(() => {
              var c;
              return [
                l("span", _, [
                  u(r(D), {
                    class: "relative shrink-0 fill-current",
                    icon: "Play",
                    size: "xs"
                  }),
                  o[3] || (o[3] = l("span", { class: "text-xxs hidden lg:flex" }, "Send", -1))
                ]),
                l("span", ee, " Send " + b(e.operation.method) + " request to " + b(((c = e.server) == null ? void 0 : c.url) ?? "") + b(e.operation.path), 1)
              ];
            }),
            _: 1
          }, 8, ["disabled"])
        ])
      ], 8, G);
    };
  }
});
export {
  ue as default
};
